import { GroupOfPropertiesTemplate } from "../../properties/factory/property-template";
import { PropertyGroup, GroupOfProperties } from "../../properties/group-of-properties";
import { ListIndex } from "../../properties/factory/list-index";
import { GroupOfPropertiesImpl } from "../../properties/group-of-properties-impl";
import { SiblingAccess } from "../../provider/list-provider/sibling-access";
import { ValidationResult } from "../../validators/validation-result";
export declare class GroupOfPropertiesBuilder {
    private readonly propertyGroup;
    constructor(propertyGroup: <T extends PropertyGroup>(id: string, properties: T) => GroupOfPropertiesImpl<T>);
    template<T extends PropertyGroup>(propertiesOfGroup: (idFcn: (id: string) => string, index?: ListIndex, siblingAccess?: SiblingAccess<GroupOfProperties<T>>) => T): GroupOfPropertiesTemplate<T>;
    of<T extends PropertyGroup>(id: string, propertiesOfGroup: T): GroupOfProperties<T>;
    bindValidator<T extends PropertyGroup>(group: GroupOfProperties<T>, validator: (group: T) => ValidationResult | Promise<ValidationResult>): void;
}
