"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupOfPropertiesBuilder = void 0;
class GroupOfPropertiesBuilder {
    constructor(propertyGroup) {
        this.propertyGroup = propertyGroup;
    }
    template(propertiesOfGroup) {
        return (id, index, siblingAccess) => this.propertyGroup(id, propertiesOfGroup(suffix => `${id}_${suffix}`, index, siblingAccess));
    }
    of(id, propertiesOfGroup) {
        return this.propertyGroup(id, propertiesOfGroup);
    }
    bindValidator(group, validator) {
        const instance = {
            getValidatedProperties: () => group.propertiesAsList,
            validate: () => validator(group.properties)
        };
        group.addValidator(instance);
    }
}
exports.GroupOfPropertiesBuilder = GroupOfPropertiesBuilder;
