"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.upgradeAsPropertyWithChoices = exports.isPropertyScalarWithChoices = void 0;
const property_scalar_impl_1 = require("./property-scalar-impl");
function isPropertyScalarWithChoices(property) {
    return property instanceof property_scalar_impl_1.PropertyScalarImpl && "getChoices" in property;
}
exports.isPropertyScalarWithChoices = isPropertyScalarWithChoices;
exports.upgradeAsPropertyWithChoices = (propertyScalar, choicesSource) => {
    const upgradedProperty = propertyScalar;
    if (choicesSource instanceof Function) {
        upgradedProperty.getChoices = choicesSource;
        upgradedProperty.awaitChoices = () => Promise.resolve(choicesSource());
    }
    else {
        upgradedProperty.getChoices = () => choicesSource.getNonNullValue();
        upgradedProperty.awaitChoices = () => choicesSource.awaitValue().then(res => res !== null && res !== void 0 ? res : []);
        upgradedProperty.isProcessing = () => choicesSource.isProcessing();
    }
    return upgradedProperty;
};
